unit FretUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFretboard = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Fretboard: TFretboard;

implementation

{$R *.DFM}

procedure TFretboard.FormPaint(Sender: TObject);
var
  n, StringSpace : integer;
begin
  with Fretboard.Canvas do
  begin
    pen.color := clBlack;

    //draw top of neck
    moveto(10,10);
    lineto(10+round(((width-30)/21))*21,10);
    //draw bottom of neck
    moveto(10,height-40);
    lineto(10+round(((width-30)/21))*21,height-40);
    //draw frets
    pen.width := 2;
    pen.color := clYellow;
    for n:=0 to 21 do
    begin
      textout(6+round(((width-30)/21))*n,0,inttostr(n));
      moveto(10+round(((width-30)/21))*n,10);
      lineto(10+round(((width-30)/21))*n,height-40);
    end;

    //Draw the strings
    StringSpace:=round((Height-60)/5);
    pen.color:=clGray;
    textout(2,12,'E');
    moveto(10,20);
    lineto(10+round(((width-30)/21))*21,20);
    for n:= 1 to 4 do
    begin
      case n of
        1 : textout(2,15+StringSpace*n-8,'B');
        2 : textout(2,15+StringSpace*n-8,'G');
        3 : textout(2,15+StringSpace*n-8,'D');
        4 : textout(2,15+StringSpace*n-8,'A');
      end;{of case}
      moveto(10,15+StringSpace*n);
      lineto(10+round(((width-30)/21))*21,15+StringSpace*n);
    end;
    textout(2,height-58,'E');
    moveto(10,height-50);
    lineto(10+round(((width-30)/21))*21,height-50);

    //draw fret dots
    pen.color := clBlack;
    ellipse(7+round(((width-30)/21)*2.5),
            12+round(StringSpace*2.5),
            13+round(((width-30)/21)*2.5),
            18+round(StringSpace*2.5));
    ellipse(7+round(((width-30)/21)*4.5),
            12+round(StringSpace*2.5),
            13+round(((width-30)/21)*4.5),
            18+round(StringSpace*2.5));
    ellipse(7+round(((width-30)/21)*6.5),
            12+round(StringSpace*2.5),
            13+round(((width-30)/21)*6.5),
            18+round(StringSpace*2.5));
    ellipse(7+round(((width-30)/21)*8.5),
            12+round(StringSpace*2.5),
            13+round(((width-30)/21)*8.5),
            18+round(StringSpace*2.5));
    ellipse(7+round(((width-30)/21)*11.5),
            12+round(StringSpace*1.5),
            13+round(((width-30)/21)*11.5),
            18+round(StringSpace*1.5));
    ellipse(7+round(((width-30)/21)*11.5),
            12+round(StringSpace*3.5),
            13+round(((width-30)/21)*11.5),
            18+round(StringSpace*3.5));
    ellipse(7+round(((width-30)/21)*14.5),
            12+round(StringSpace*2.5),
            13+round(((width-30)/21)*14.5),
            18+round(StringSpace*2.5));
    ellipse(7+round(((width-30)/21)*16.5),
            12+round(StringSpace*2.5),
            13+round(((width-30)/21)*16.5),
            18+round(StringSpace*2.5));
    ellipse(7+round(((width-30)/21)*18.5),
            12+round(StringSpace*2.5),
            13+round(((width-30)/21)*18.5),
            18+round(StringSpace*2.5));
    ellipse(7+round(((width-30)/21)*20.5),
            12+round(StringSpace*2.5),
            13+round(((width-30)/21)*20.5),
            18+round(StringSpace*2.5));
    //ellipse(20,20,25,25);
  end;

end;

procedure TFretboard.FormResize(Sender: TObject);
begin
  Fretboard.refresh;
end;

end.
